<?
/*
*********************************************************************************************************
 IP-SYMCON Event Scriptingclass
*********************************************************************************************************
File     : class.eFHT.php
*/
include_once(IPS_GetKernelDir()."bricks\eFHZ\class.eFHZ.php");
class eFHT extends eFHZ {
   private static $FHT_Instance;
   private static $FHT_Housecode;
   private static $FHT_Name;
   private static $FHT_Location;
   private static $FHT_Settings;
   
   private static $instance;
   private static $S1Buffer=array();
   private static $OK=false;
   private static $invarA;
   private static $outvarA;
   private static $PtyT;

   // ***************************************************************************************************      
   // * Funktionen fr die FHT's
   // ***************************************************************************************************      
   // Variablenfunktionen
   public function vFHT_GetInstance() {return self::$FHT_Instance;}   
   public function vFHT_GetHousecode() {return self::$FHT_Housecode;}   
   public function vFHT_GetName() {return self::$FHT_Name;}   
   public function vFHT_GetLocation() {return self::$FHT_Location;}   
   public function vFHT_GetSettings() {return self::$FHT_Settings;} 
   public function vFHT_GetActualTemperature() {
	   return parent::xipsvarget(self::$FHT_Settings['Settings']['TemeratureVar'],'Float');
   }  
   public function vFHT_GetTargetTemperature() {
	   return parent::xipsvarget(self::$FHT_Settings['Settings']['TargetTempVar'],'Float');
   }  
   public function vFHT_GetTargetSunTemperature() {
	   return self::xefhtvarget(7);
   }  
   public function vFHT_GetTargetLunaTemperature() {
	   return self::xefhtvarget(8);
   }  
   public function vFHT_GetTargetWindTemperature() {
	   return self::xefhtvarget(9);
   }  
   public function vFHT_GetTargetMode() {
	   return parent::xipsvarget(self::$FHT_Settings['Settings']['TargetModeVar'],'Integer');
   }  
   public function vFHT_GetActualPosition() {
	   return parent::xipsvarget(self::$FHT_Settings['Settings']['PositionVar'],'Float');
   }  
   public function vFHT_GetTargetWPMode($timestamp) {
      return (parent::xfhtwpmode(self::xefhtvarget(6),$timestamp));
   }
   public function vFHT_GetTargetWPTemp($timestamp) {
      $Value=parent::xfhtwpmode(self::xefhtvarget(6),$timestamp);
      if ($Value==3) return ((float)self::xefhtvarget(7));
      if ($Value==2) return ((float)self::xefhtvarget(8));
      return 17;
   }
   public function vFHT_DecodeWP($Day,$e_sign="--:--",$Target=true) {
      $arr=array();
      if (!is_array($wp=unserialize(self::xefhtvarget((($Target==true) ? 6 : 1))))) return false;
      $cntr=($Day>=7) ? 6 : 0;
      for($i=0;$i<=$cntr;$i++) {
         if ($cntr==0) {$idx=($Day==0) ? 6 : ($Day-1);}
         else {$idx=($i==6) ? 0 : ($i+1);}
         for($j=0;$j<=3;$j++) {
            $v=$wp[($idx*4)+$j];$idn=($idx==6) ? 0 : ($idx+1);
            if ($v==144) {$arr[$idn][$j]=$e_sign;}
            else {
               $x=$wp[($idx*4)+$j]/6;$y=round(($x-intval($x))*60,0);
               $arr[$idn][$j]=sprintf("%02d:%02d", intval($x), $y);
            }
         }
      }
      ksort($arr);
      return $arr;
   }
   // Bufferfunktionen
   public function bFHT_ClrBuffer() {
      self::$S1Buffer=array();
      return true;
   }
   public function bFHT_RclActualState() {
      if (self::$OK) {
         self::xsrclbit(0x66,0);self::xsrclbit(0x66,5);
         return true;
      }
      else return false;
   }
   public function bFHT_RclTargetState() {
      if (self::$OK) {
         self::xsrclbit(0x66,1);self::xsrclbit(0x66,2);self::xsrclbit(0x66,3);
         return true;
      }
      else return false;
   }
   public function bFHT_RclWeekProgram($Day=7) {
      if (self::$OK) {
         self::$S1Buffer[0x65]=($Day>=7 ? 127 : ((($Day-=1)<0) ? 64 : 1<<$Day));
         return true;
      }
      else return false;
   }
   public function bFHT_SetTemperature($value) {
      if (self::xchkTmp($value) && self::$OK) {
         self::$S1Buffer[0x41]=$value*2;
         self::xsrclbit(0x66,3);
         return true;
      }
      else return false;
   }
   public function bFHT_SetSunTemperature($value) {
      if (self::xchkTmp($value) && self::$OK) {
         self::$S1Buffer[0x82]=$value*2;
         self::xsrclbit(0x66,2);
         return true;
      }
      else return false;
   }
   public function bFHT_SetLunaTemperature($value) {
      if (self::xchkTmp($value) && self::$OK) {
         self::$S1Buffer[0x84]=$value*2;
         self::xsrclbit(0x66,2);
         return true;
      }
      else return false;
   }
   public function bFHT_SetWindTemperature($value) {
      if (self::xchkTmp($value) && self::$OK) {
         self::$S1Buffer[0x8a]=$value*2;
         self::xsrclbit(0x66,2);
         return true;
      }
      else return false;
   }
   public function bFHT_SetMode($Mode,$leap=false) {
      if (self::$OK) {
         if ($Mode>1) {
            $timestamp=$Mode;
            $st_t=parent::xfhtleap(time(),$leap)+1200;if ($timestamp<$st_t) $timestamp=$st_t;
            $dif=$timestamp-$st_t;
            if ($dif>86400) {
               if ($dif>101*86400) $dif=101*86400;
               self::$PtyT=mktime(0,0,0,date("m",$st_t+$dif),date("d",$st_t+$dif),date("Y"));$Mode=2;
               self::$S1Buffer[0x3f]=(int)date("d",self::$PtyT);
               self::$S1Buffer[0x40]=(int)date("m",self::$PtyT);
            }
            else {
               self::$PtyT=$timestamp;
               self::$S1Buffer[0x3f]=(((float)(date("H",self::$PtyT)))+((round((date("i",self::$PtyT))/10+0.4,0))*1/6))*6;
               self::$S1Buffer[0x40]=(int)date("d",self::$PtyT);
               $Mode=3;
            }
         }
         self::$S1Buffer[0x3e]=$Mode;
         self::xsrclbit(0x66,1);
         return true;
      }
      else return false;
   }
   public function bFHT_SendTo($ClrB=true) {
      if (self::$OK && count(self::$S1Buffer)>0) {
         ksort(self::$S1Buffer);
         while (list($key,$val)=each(self::$S1Buffer)) {
            if ($key==0x3e) {
               if (parent::xipsvarget(self::$FHT_Settings['Settings']['TargetIPSModeVar'],'String')!=$val) {
                  self::xefhtvarset(0,'');
               }
               parent::xipsvarset(self::$FHT_Settings['Settings']['TargetIPSModeVar'],'Integer',$val);
            }
            if ($key==0x3f) {
               $ti=date("H:i:s d.m.Y",($to=mktime(($h=round((self::$S1Buffer[0x3f]/6),-1)),(self::$S1Buffer[0x3f]/6-$h)*60,0))+(self::$S1Buffer[0x40]!=(int)date("d",$to) ? 1 : 0)*86400);
	            self::xefhtvarset(0,$ti);
            }
	         if ($key==0x41) parent::xipsvarset(self::$FHT_Settings['Settings']['TargetIPSTempVar'],'Float',$val/2);
	         if ($key==0x82) self::xefhtvarset(2,$val/2);
	         if ($key==0x84) self::xefhtvarset(3,$val/2);
	         if ($key==0x8a) self::xefhtvarset(4,$val/2);
         }
         $str=parent::xbuildsndstr(array(4=>2,5=>1,6=>0x83),self::$S1Buffer);
         $str=self::xstrHC($str);$str=parent::xstrBC($str);$str[2]=4;
         if ($ClrB) self::$S1Buffer=array();
         return (parent::xsndstr($str));
      }
      else return false;
   }
   // Singlefunktionen
   public function sFHT_Init() {
      if (self::$OK) {
         $S2Buffer=array();$S2Buffer[0x65]=0xff;$S2Buffer[0x66]=0xff;
         $str=parent::xbuildsndstr(array(4=>2,5=>1,6=>0x83),$S2Buffer);
         $str=self::xstrHC($str);$str=parent::xstrBC($str);$str[2]=4;
         $S2Buffer=array();
         return (parent::xsndstr($str));
      }
      else return false;
   }
   public function sFHT_SetDateAndTime($timestamp=0,$leap=false) {
      if ($timestamp==0) $timestamp=time();
      $timestamp=parent::xfhtleap($timestamp,$leap);
      if (self::$OK) {
         $S2Buffer=array();
         $S2Buffer[0x60]=(int)date("y",$timestamp);
         $S2Buffer[0x61]=(int)date("m",$timestamp);
         $S2Buffer[0x62]=(int)date("d",$timestamp);
         $S2Buffer[0x63]=(int)date("H",$timestamp);
         $S2Buffer[0x64]=(int)date("i",$timestamp);
         $str=parent::xbuildsndstr(array(4=>2,5=>1,6=>0x83),$S2Buffer);
         $str=self::xstrHC($str);$str=parent::xstrBC($str);$str[2]=4;
         $S2Buffer=array();
         return (parent::xsndstr($str));
      }
      else return false;
   }
   public function sFHT_SetWeekProgram($Day,$Von1=false,$Bis1=false,$Von2=false,$Bis2=false) {
      if (self::$OK) {
         $S2Buffer=array();
         if (($Day=(int)$Day)<7) {
            $S2Buffer[0x65]=(($Day-=1)<0) ? 64 : 1<<$Day;
            $reg=20+(($Day<0) ? 6 : $Day)*4;
            if ($Von1===false||$Bis1===false) {$Von1=false;$Bis1=false;$Von2=false;$Bis2=false;}
            else {
               if ((!is_string($Von1))||(($Von1=strtotime($Von1,0))===false)) {return false;}
               if ((!is_string($Bis1))||(($Bis1=strtotime($Bis1,0))===false)) {return false;}
            }
            if ($Von2===false||$Bis2===false) {$Von2=false;$Bis2=false;}
            else {
               if ((!is_string($Von2))||(($Von2=strtotime($Von2,0))===false)) {return false;}
               if ((!is_string($Bis2))||(($Bis2=strtotime($Bis2,0))===false)) {return false;}
            }
            if (!is_array($wp=unserialize(self::$invarA[1][2]))) {$wp=array_fill(0,28,144);}
            if ($Von1!==false) $S2Buffer[$reg]=(((float)(date("H",$Von1)))+((float)(date("i",$Von1))/60))*6;
            else $S2Buffer[$reg]=144;
            $wp[$reg-20]=$S2Buffer[$reg];
            if ($Bis1!==false) $S2Buffer[$reg+1]=(((float)(date("H",$Bis1)))+((float)(date("i",$Bis1))/60))*6;
            else $S2Buffer[$reg+1]=144;
            $wp[$reg-19]=$S2Buffer[$reg+1];
            if ($Von2!==false) $S2Buffer[$reg+2]=(((float)(date("H",$Von2)))+((float)(date("i",$Von2))/60))*6;
            else $S2Buffer[$reg+2]=144;
            $wp[$reg-18]=$S2Buffer[$reg+2];
            if ($Bis2!==false) $S2Buffer[$reg+3]=(((float)(date("H",$Bis2)))+((float)(date("i",$Bis2))/60))*6;
            else $S2Buffer[$reg+3]=144;
            $wp[$reg-17]=$S2Buffer[$reg+3];
            
            $str=parent::xbuildsndstr(array(4=>2,5=>1,6=>0x83),$S2Buffer);
            $str=self::xstrHC($str);$str=parent::xstrBC($str);$str[2]=4;
            $S2Buffer=array();
            self::xefhtvarset(1,serialize($wp));
            return (parent::xsndstr($str));
         }
         else return false;
      }
      else return false;
   }
   // ***************************************************************************************************      
   // * Funktionen fr die Klasse
   // ***************************************************************************************************      
   public static function Begin($Brick) {
      if (!isset(self::$instance)) {
         $c = __CLASS__;
         $instance = new $c;
      }
      if (IPS_ScriptExists($Brick)) {
         parent::Begin();
         include(IPS_GetScriptFile($Brick));
         self::$invarA=$invars;self::$outvarA=$outvars;
         $xml = new IPS_XMLParser();
         if ($__instance>0) {     
            $xml = new IPS_XMLParser();
            self::$OK=false;
            if ($__instance>0) {
               $settings=$xml->GetArray(IPS_GetInstanceSettings($__instance));
               $settings=$settings['ID'];
               if ($settings['ModuleName']=='FHT') {
                  self::$FHT_Instance=$__instance;
                  self::$FHT_Settings=$settings;
                  if (array_key_exists('LOCATION',$settings)&&array_key_exists('NAME',$settings['LOCATION'])) {
                     self::$FHT_Name=self::$FHT_Settings['LOCATION']['NAME'];
                  }
                  if (array_key_exists('LOCATION',$settings)&&array_key_exists('LEVEL',$settings['LOCATION'])) {
                     self::$FHT_Location=self::$FHT_Settings['LOCATION']['LEVEL'];
                  }
                  self::$FHT_Housecode=((self::$FHT_Settings['Settings']['DeviceAdress']&0xff00)>>8)*100+(self::$FHT_Settings['Settings']['DeviceAdress']&0xff);              
               }
            }
            if (self::$FHT_Instance && parent::vFHZ_IsReady()) {self::$OK=true;}
         }
         $xml=null;
         return true;
      }
      else return false;
   }
   private function xsrclbit($key,$bit) {
      if (!isset(self::$S1Buffer[$key])) self::$S1Buffer[$key]=1;
      self::$S1Buffer[$key]=(self::$S1Buffer[$key]|1<<$bit);
   }
   private function xchkTmp($Value) {
      $Value=(float)$Value;
      if ($Value>=5.5 && $Value<=30.5) return true;
      else return false;
   }
   private function xstrHC($arr) {
      $arr[7]=(self::$FHT_Settings['Settings']['DeviceAdress']&0xff00)>>8;$arr[8]=self::$FHT_Settings['Settings']['DeviceAdress'] & 0xff;
      return $arr;
   }
   private function xefhtvarset($index,$val) {
      if (strlen(self::$invarA[$index][0])>0) {
         if (IPS_VariableExists(self::$invarA[$index][0])) {
            if (self::$invarA[$index][1]=="String") {SetValueString(self::$invarA[$index][0],(string)$val);}
            if (self::$invarA[$index][1]=="Boolean") {SetValueBoolean(self::$invarA[$index][0],$val);}
            if (self::$invarA[$index][1]=="Float") {SetValueFloat(self::$invarA[$index][0],(float)$val);}
            if (self::$invarA[$index][1]=="Integer") {SetValueInteger(self::$invarA[$index][0],(int)$val);}
         }
      }
   }
   private function xefhtvarget($index) {
      if (strlen(self::$invarA[$index][0])>0) {
         if (IPS_VariableExists(self::$invarA[$index][0])) {return self::$invarA[$index][2];}
      }
      else return false;
   }
}

?>
